<script setup lang="ts">
import { defineProps } from 'vue'
import { useProductStore } from '@/stores/Product'
import type { PromotionItem } from '@/types/PromotionItem'

const productStore = useProductStore()

const props = defineProps({
  promotionItems: Array as () => PromotionItem[]
})
</script>
<template>
  <div>
    <template v-for="(promotionItem, index) in props.promotionItems" :key="index">
      <div v-if="promotionItem.productId === null">
        <!-- Check if item has no product id -->
        <template
          v-if="promotionItem.conditionPrice !== null && promotionItem.conditionQty === null"
        >
          <!-- Check if item has conditionPrice -->
          <template
            v-if="promotionItem.discountPrice !== null && promotionItem.discountPercent === null"
          >
            <p>ยอดซื้อขั้นต่ำ: {{ promotionItem.conditionPrice }} บาท</p>
            <p>ส่วนลด: {{ promotionItem.discountPrice }} บาท</p>
            <p>ใช้ได้กับทุกสินค้า</p>
          </template>
          <!-- Check if item has discountPercent -->
          <template
            v-else-if="
              promotionItem.discountPrice === null && promotionItem.discountPercent !== null
            "
          >
            <p>ยอดซื้อขั้นต่ำ: {{ promotionItem.conditionPrice }} บาท</p>
            <p>ส่วนลด: {{ promotionItem.discountPercent }}%</p>
            <p>ใช้ได้กับทุกสินค้า</p>
          </template>
        </template>
        <!-- Check if item has conditionQty -->
        <template
          v-else-if="promotionItem.conditionPrice === null && promotionItem.conditionQty !== null"
        >
          <!-- Check if item has discountPrice -->
          <template
            v-if="promotionItem.discountPrice !== null && promotionItem.discountPercent === null"
          >
            <p>ยอดซื้อขั้นต่ำ: {{ promotionItem.conditionQty }} หน่วย</p>
            <p>ส่วนลด: {{ promotionItem.discountPrice }} บาท</p>
            <p>ใช้ได้กับทุกสินค้า</p>
          </template>
          <!-- Check if item has discountPercent -->
          <template
            v-else-if="
              promotionItem.discountPrice === null && promotionItem.discountPercent !== null
            "
          >
            <p>ยอดซื้อขั้นต่ำ: {{ promotionItem.conditionQty }} หน่วย</p>
            <p>ส่วนลด: {{ promotionItem.discountPercent }} %</p>
            <p>ใช้ได้กับทุกสินค้า</p>
          </template>
        </template>
      </div>
      <div v-else>
        <!-- Check if item has product id -->
        <template
          v-if="promotionItem.conditionPrice !== null && promotionItem.conditionQty === null"
        >
          <!-- Check if item has conditionPrice -->
          <template
            v-if="promotionItem.discountPrice !== null && promotionItem.discountPercent === null"
          >
            <p>เมื่อซื้อ "{{ productStore.searchProduct(promotionItem.productId)?.name }}"</p>
            <p>ยอดซื้อขั้นต่ำ: {{ promotionItem.conditionPrice }} บาท</p>
            <p>จะได้รับส่วนลด: {{ promotionItem.discountPrice }} บาท</p>
          </template>
          <!-- Check if item has discountPercent -->
          <template
            v-else-if="
              promotionItem.discountPrice === null && promotionItem.discountPercent !== null
            "
          >
            <p>เมื่อซื้อ "{{ productStore.searchProduct(promotionItem.productId)?.name }}"</p>
            <p>ยอดซื้อขั้นต่ำ: {{ promotionItem.conditionPrice }} บาท</p>
            <p>จะได้รับส่วนลด: {{ promotionItem.discountPercent }}%</p>
          </template>
        </template>
        <!-- Check if item has conditionQty -->
        <template
          v-else-if="promotionItem.conditionPrice === null && promotionItem.conditionQty !== null"
        >
          <!-- Check if item has discountPrice -->
          <template
            v-if="promotionItem.discountPrice !== null && promotionItem.discountPercent === null"
          >
            <p>เมื่อซื้อ "{{ productStore.searchProduct(promotionItem.productId)?.name }}"</p>
            <p>ครบ {{ promotionItem.conditionQty }} หน่วย</p>
            <p>จะได้รับส่วนลด: {{ promotionItem.discountPrice }} บาท</p>
          </template>
          <!-- Check if item has discountPercent -->
          <template
            v-else-if="
              promotionItem.discountPrice === null && promotionItem.discountPercent !== null
            "
          >
            <p>เมื่อซื้อ "{{ productStore.searchProduct(promotionItem.productId)?.name }}"</p>
            <p>ครบ {{ promotionItem.conditionQty }} หน่วย</p>
            <p>จะได้รับส่วนลด: {{ promotionItem.discountPercent }}%</p>
          </template>
        </template>
        <template v-else-if="promotionItems && promotionItems.length >= 2">
          <p>Promotionitem more than or equal 2 ทำไม่ทัน</p>
        </template>
        <template v-else-if="promotionItems! === undefined || promotionItems!.length === 0">
          <p>No Promotion Items</p>
        </template>
      </div>
    </template>
  </div>
</template>
